function love.load()
	require "levels/level"
	require 'camera'
	
	guy = love.graphics.newImage("textures/player.png")
	lava = love.graphics.newImage("textures/lava.png")
	brick = love.graphics.newImage("textures/brick.png")
	wall = love.graphics.newImage("textures/wall.png")
	player = {
		level = 1,
		x,
		y,
		ySpeed = 0,
		grav = 1.5,
		levelwidth,
		levelheight,
		}
	level_load()
	for y = 1, #map do
		for x = 1, #map[y] do
			if map[y][x] == 3 then
				player.x = x * 32 - 32
				player.y = y * 32 - 32
			end
		end
	end
	width = love.graphics.getWidth()
    height = love.graphics.getHeight()
    camera:setBounds(0, 0, player.levelwidth * 32 - width, player.levelheight * 32 - height)
	
	tiles = {}
	tiles[0] = wall
	tiles[1] = brick
	tiles[2] = lava
	tiles[3] = wall
end

function love.update(dt)
	dt = math.min(dt, 0.07)
	if love.keyboard.isDown( "q" ) then
		dt = math.min(dt/4, 0.07)
	end
	frame = dt * 30
	player.ySpeed = player.ySpeed + player.grav * frame
	player.y = player.y + player.ySpeed * frame
	boundingChecks()
	camera:setPosition(player.x - width / 2, player.y - height / 2)
end

function love.keypressed(key)
	if key == "up" and player.ySpeed == 0 then
			player.ySpeed = -20
	end
end

function boundingChecks()
	if mapCollide(player.x + 1, player.y + 32, player, map) == 1 or mapCollide(player.x + 31, player.y + 32, player, map) == 1 then
		player.y = player.y - player.ySpeed * frame
		player.ySpeed = 0
	end
	if mapCollide(player.x + 1, player.y, player, map) == 1 or mapCollide(player.x + 31, player.y, player, map) == 1 then
		player.ySpeed = .5
	end
	if love.keyboard.isDown("left") then
		player.x = player.x - 8 * frame
	end
	if love.keyboard.isDown("right") then
		player.x = player.x + 8 * frame
	end
	if mapCollide(player.x, player.y + 1, player, map) == 1 or mapCollide(player.x, player.y + 31, player, map) == 1 then
		player.x = player.x + 8 * frame
	end
	if mapCollide(player.x + 32, player.y + 1, player, map) == 1 or mapCollide(player.x + 32, player.y + 31, player, map) == 1 then
		player.x = player.x - 8 * frame
	end
end

function love.draw()
camera:set()
		for y=1, #map do --draws the map
        	for x=1, #map[y] do
				love.graphics.draw(tiles[map[y][x]] , x * 32 - 32, y * 32 - 32) 
        	end
    	end
		love.graphics.setColor(255, 255, 255)--draw player
		love.graphics.draw(guy, player.x, player.y)
camera:unset()
end

function mapCollide(x, y)--qualities
	checkMap = map[math.floor(y/32) + 1][math.floor(x/32) + 1]
	if checkMap==0 then
	end
	if checkMap==1 then
	end
	if checkMap==2 then
		DrawPlayer(player, map)
	end
	return checkMap
end

function DrawPlayer(player, map)
		for y = 1, #map do
			for x = 1, #map[y] do
				if map[y][x] == 3 then
					player.x = x * 32 - 32
					player.y = y * 32 - 32
				end
			end
		end
end

function love.mousepressed( x, y, button )
    x = camera:RePositionX(x)
	y = camera:RePositionY(y)
end

function math.clamp(x, min, max)
  	return x < min and min or (x > max and max or x)
end